commit 2090aea9a7a7ca185817a5b04da7c822f3c6d464
Author: jklowden <jklowden>
Date:   Fri Jul 4 21:08:38 2008 +0000

    src/odbc/prepare_query.c src/odbc/unittests/blob1.c Applied patch from ML Suren A. Chiling 3 July 2008

diff --git a/ChangeLog b/ChangeLog
index bdea5ce..eeed084 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,11 @@
+Fri Jul  4 16:59:48 EDT 2008	JK Lowden <jklowden@freetds.org>
+	* include/tds.h src/odbc/odbc.c
+	- src/odbc/prepare_query.c src/odbc/unittests/blob1.c
+	- Applied patch from ML Suren A. Chiling 3 July 2008
+	* src/tds/query.c fixed warning and formatting
+	* TODO added NetBSD note
+	* src/dblib/dblib.c NTBSTRINGBIND attempt
+
 Tue Jun 25 13:54:29 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/cursor7.c: cleanup
 
@@ -357,4 +365,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2537 2008/06/25 11:54:35 freddy77 Exp $
+$Id: ChangeLog,v 1.2538 2008/07/04 21:08:38 jklowden Exp $
diff --git a/include/tds.h b/include/tds.h
index e2dae20..e90a226 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.289 2008/06/18 09:06:26 freddy77 Exp $ */
+/* $Id: tds.h,v 1.290 2008/07/04 21:08:39 jklowden Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1009,6 +1009,7 @@ typedef struct tds_column
 	TDS_INT *column_lenbind;
 	TDS_INT column_textpos;
 	TDS_INT column_text_sqlgetdatapos;
+	TDS_CHAR column_text_sqlputdatainfo;
 
 	BCPCOLDATA *bcp_column_data;
 	/**
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 92c1284..75645f2 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.483 2008/06/18 09:06:26 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.484 2008/07/04 21:08:39 jklowden Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -4652,6 +4652,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 	SQLLEN dummy_cb;
 	int nSybType;
 
+	TDS_INT converted_column_cur_size;
 	int extra_bytes = 0;
 
 	INIT_HSTMT;
@@ -4690,6 +4691,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
 	colinfo = tds->current_results->columns[icol - 1];
+	converted_column_cur_size = colinfo->column_cur_size;
 
 	if (colinfo->column_cur_size < 0) {
 		*pcbValue = SQL_NULL_DATA;
@@ -4715,7 +4717,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 			if (is_blob_type(colinfo->column_type))
 				src = ((TDSBLOB *) src)->textvalue;
 
-			if (fCType == SQL_C_CHAR && colinfo->column_text_sqlgetdatapos) {
+			if (fCType == SQL_C_CHAR) {
 				TDS_CHAR buf[3];
 				SQLLEN len;
 
@@ -4758,40 +4760,15 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 						}
 					} else {
 						nread = colinfo->column_text_sqlgetdatapos / 2;
-						if (nread >= colinfo->column_cur_size)
+						
+						if (colinfo->column_text_sqlgetdatapos > 0
+						    && nread >= colinfo->column_cur_size)
 							ODBC_RETURN(stmt, SQL_NO_DATA);
 					}
 					
 					src += nread;
 					srclen = colinfo->column_cur_size - nread;
-					break;
-				default:
-					if (colinfo->column_text_sqlgetdatapos >= colinfo->column_cur_size)
-						ODBC_RETURN(stmt, SQL_NO_DATA);
-						
-					src += colinfo->column_text_sqlgetdatapos;
-					srclen = colinfo->column_cur_size - colinfo->column_text_sqlgetdatapos;
-
-				}
-			} else if (fCType == SQL_C_BINARY) {
-				switch (nSybType) {
-				case SYBCHAR:
-				case SYBVARCHAR:
-				case SYBTEXT:
-				case XSYBCHAR:
-				case XSYBVARCHAR:
-					nread = (src[0] == '0' && toupper(src[1]) == 'X')? 2 : 0;
-						
-					while ((nread < colinfo->column_cur_size) && (src[nread] == ' ' || src[nread] == '\0')) 
-						nread++;
-
-					nread += colinfo->column_text_sqlgetdatapos * 2;
-					
-					if (nread && nread >= colinfo->column_cur_size)
-						ODBC_RETURN(stmt, SQL_NO_DATA);
-
-					src += nread;
-					srclen = colinfo->column_cur_size - nread;
+					converted_column_cur_size *= 2;
 					break;
 				default:
 					if (colinfo->column_text_sqlgetdatapos > 0
@@ -4842,7 +4819,7 @@ SQLGetData(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLSMALLINT fCType, SQLPOINTER rgb
 			if (colinfo->column_text_sqlgetdatapos == 0 && cbValueMax > 0)
 				++colinfo->column_text_sqlgetdatapos;
 			
-			if (colinfo->column_text_sqlgetdatapos < colinfo->column_cur_size) {	/* not all read ?? */
+			if (colinfo->column_text_sqlgetdatapos < converted_column_cur_size) {	/* not all read ?? */
 				odbc_errs_add(&stmt->errs, "01004", "String data, right truncated");
 				ODBC_RETURN(stmt, SQL_SUCCESS_WITH_INFO);
 			}

